/* gcalc-calculator.c generated by valac 0.56.11, the Vala compiler
 * generated from gcalc-calculator.vala, do not modify */

/* gcalc-calculator.vala
 *
 * Copyright (C) 2022  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gcalc/gcalc.h"
#include <glib.h>
#include <mpc.h>
#include "mpfrg.h"
#include <mpfr.h>
#include <glib-object.h>
#include "gcalc.h"

enum  {
	GCALC_CALCULATOR_0_PROPERTY,
	GCALC_CALCULATOR_NUM_PROPERTIES
};
static GParamSpec* gcalc_calculator_properties[GCALC_CALCULATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer gcalc_calculator_parent_class = NULL;

VALA_EXTERN void gcalc_constant_get_complex (GCalcConstant* self,
                                 __mpc_struct* result);
static GType gcalc_calculator_get_type_once (void);

GCalcMathConstant*
gcalc_calculator_add (GCalcMathConstant* c1,
                      GCalcMathConstant* c2)
{
	GCalcConstant* c = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* result;
#line 25 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 25 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, NULL);
#line 26 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 26 "../gcalc/gcalc-calculator.vala"
	c = _tmp0_;
#line 27 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_add ((GCalcMathConstant*) c, c2);
#line 27 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 27 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (c);
#line 27 "../gcalc/gcalc-calculator.vala"
	return result;
#line 71 "gcalc-calculator.c"
}

/**
     * Substract C2 to C1 operation (c1 - c2)
     */
GCalcMathConstant*
gcalc_calculator_subtract (GCalcMathConstant* c1,
                           GCalcMathConstant* c2)
{
	GCalcConstant* c = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* result;
#line 32 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 32 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, NULL);
#line 33 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 33 "../gcalc/gcalc-calculator.vala"
	c = _tmp0_;
#line 34 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_subtract ((GCalcMathConstant*) c, c2);
#line 34 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 34 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (c);
#line 34 "../gcalc/gcalc-calculator.vala"
	return result;
#line 101 "gcalc-calculator.c"
}

GCalcMathConstant*
gcalc_calculator_multiply (GCalcMathConstant* c1,
                           GCalcMathConstant* c2)
{
	GCalcConstant* c = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* result;
#line 36 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 36 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, NULL);
#line 37 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 37 "../gcalc/gcalc-calculator.vala"
	c = _tmp0_;
#line 38 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_multiply ((GCalcMathConstant*) c, c2);
#line 38 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 38 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (c);
#line 38 "../gcalc/gcalc-calculator.vala"
	return result;
#line 128 "gcalc-calculator.c"
}

/**
     * Divide c1/c2
     */
GCalcMathConstant*
gcalc_calculator_divide (GCalcMathConstant* c1,
                         GCalcMathConstant* c2)
{
	GCalcConstant* c = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* _tmp2_;
	GCalcMathConstant* result;
#line 43 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 43 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, NULL);
#line 44 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 44 "../gcalc/gcalc-calculator.vala"
	c = _tmp0_;
#line 45 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_divide ((GCalcMathConstant*) c, c2);
#line 45 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = _tmp1_;
#line 45 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (_tmp2_);
#line 46 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) c;
#line 46 "../gcalc/gcalc-calculator.vala"
	return result;
#line 161 "gcalc-calculator.c"
}

/**
     * Calculates the negative value of c
     */
GCalcMathConstant*
gcalc_calculator_neg (GCalcMathConstant* c)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* result;
#line 51 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c != NULL, NULL);
#line 52 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c);
#line 52 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 53 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_neg ((GCalcMathConstant*) rc);
#line 53 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 53 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (rc);
#line 53 "../gcalc/gcalc-calculator.vala"
	return result;
#line 188 "gcalc-calculator.c"
}

/**
     * Calculates c raised to p
     */
GCalcMathConstant*
gcalc_calculator_pow (GCalcMathConstant* c,
                      GCalcMathConstant* p)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	GCalcMathConstant* _tmp1_;
	GCalcMathConstant* result;
#line 58 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c != NULL, NULL);
#line 58 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 59 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c);
#line 59 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 60 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_math_constant_pow ((GCalcMathConstant*) rc, p);
#line 60 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 60 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (rc);
#line 60 "../gcalc/gcalc-calculator.vala"
	return result;
#line 218 "gcalc-calculator.c"
}

/**
     * Calculates square root of c
     */
GCalcMathConstant*
gcalc_calculator_sqrt (GCalcMathConstant* c)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcMathConstant* result;
#line 65 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c != NULL, NULL);
#line 66 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c);
#line 66 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 67 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 67 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 67 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp3_);
#line 67 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 67 "../gcalc/gcalc-calculator.vala"
	mpfr_sqrt (&_tmp2_->val, &_tmp4_->val, MPFR_RNDN);
#line 68 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 68 "../gcalc/gcalc-calculator.vala"
	return result;
#line 254 "gcalc-calculator.c"
}

/**
     * Creates a constant with the value of constant PI
     */
GCalcMathConstant*
gcalc_calculator_pi (void)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	GCalcMathConstant* result;
#line 74 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 74 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 75 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 75 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 75 "../gcalc/gcalc-calculator.vala"
	mpfr_const_pi (&_tmp2_->val, MPFR_RNDN);
#line 76 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 76 "../gcalc/gcalc-calculator.vala"
	return result;
#line 282 "gcalc-calculator.c"
}

/**
     * Creates a constant with the value of constant logarithm of 2
     */
GCalcMathConstant*
gcalc_calculator_log2 (void)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	GCalcMathConstant* result;
#line 82 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 82 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 83 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 83 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 83 "../gcalc/gcalc-calculator.vala"
	mpfr_const_log2 (&_tmp2_->val, MPFR_RNDN);
#line 84 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 84 "../gcalc/gcalc-calculator.vala"
	return result;
#line 310 "gcalc-calculator.c"
}

/**
     * Creates a constant with the value of constant EULER
     */
GCalcMathConstant*
gcalc_calculator_euler (void)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	GCalcMathConstant* result;
#line 90 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 90 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 91 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 91 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 91 "../gcalc/gcalc-calculator.vala"
	mpfr_const_euler (&_tmp2_->val, MPFR_RNDN);
#line 92 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 92 "../gcalc/gcalc-calculator.vala"
	return result;
#line 338 "gcalc-calculator.c"
}

/**
     * Creates a constant with the value of constant CATALAN
     */
GCalcMathConstant*
gcalc_calculator_catalan (void)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	GCalcMathConstant* result;
#line 98 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 98 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 99 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 99 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 99 "../gcalc/gcalc-calculator.vala"
	mpfr_const_catalan (&_tmp2_->val, MPFR_RNDN);
#line 100 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 100 "../gcalc/gcalc-calculator.vala"
	return result;
#line 366 "gcalc-calculator.c"
}

/**
     * Operator c1 = c2 (equal)
     */
gboolean
gcalc_calculator_eq (GCalcMathConstant* c1,
                     GCalcMathConstant* c2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	__mpc_struct _tmp2_ = {0};
	__mpc_struct _tmp3_ = {0};
	gboolean result;
#line 105 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, FALSE);
#line 105 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, FALSE);
#line 106 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 106 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = TRUE;
#line 389 "gcalc-calculator.c"
	} else {
#line 106 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = !GCALC_IS_CONSTANT (c2);
#line 393 "gcalc-calculator.c"
	}
#line 106 "../gcalc/gcalc-calculator.vala"
	if (_tmp0_) {
#line 107 "../gcalc/gcalc-calculator.vala"
		result = FALSE;
#line 107 "../gcalc/gcalc-calculator.vala"
		return result;
#line 401 "gcalc-calculator.c"
	}
#line 110 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp2_);
#line 110 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c2, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp3_);
#line 110 "../gcalc/gcalc-calculator.vala"
	if (mpc_cmp (&_tmp2_, &_tmp3_) == 0) {
#line 110 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = TRUE;
#line 411 "gcalc-calculator.c"
	} else {
#line 110 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = FALSE;
#line 415 "gcalc-calculator.c"
	}
#line 110 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 110 "../gcalc/gcalc-calculator.vala"
	return result;
#line 421 "gcalc-calculator.c"
}

/**
     * Operator c1 > c2
     */
gboolean
gcalc_calculator_gt (GCalcMathConstant* c1,
                     GCalcMathConstant* c2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	__mpc_struct _tmp2_ = {0};
	__mpc_struct _tmp3_ = {0};
	gboolean result;
#line 115 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, FALSE);
#line 115 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, FALSE);
#line 116 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 116 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = TRUE;
#line 444 "gcalc-calculator.c"
	} else {
#line 116 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = !GCALC_IS_CONSTANT (c2);
#line 448 "gcalc-calculator.c"
	}
#line 116 "../gcalc/gcalc-calculator.vala"
	if (_tmp0_) {
#line 117 "../gcalc/gcalc-calculator.vala"
		result = FALSE;
#line 117 "../gcalc/gcalc-calculator.vala"
		return result;
#line 456 "gcalc-calculator.c"
	}
#line 120 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp2_);
#line 120 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c2, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp3_);
#line 120 "../gcalc/gcalc-calculator.vala"
	if (mpc_cmp (&_tmp2_, &_tmp3_) > 0) {
#line 120 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = TRUE;
#line 466 "gcalc-calculator.c"
	} else {
#line 120 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = FALSE;
#line 470 "gcalc-calculator.c"
	}
#line 120 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 120 "../gcalc/gcalc-calculator.vala"
	return result;
#line 476 "gcalc-calculator.c"
}

/**
     * Operator c1 < c2
     */
gboolean
gcalc_calculator_lt (GCalcMathConstant* c1,
                     GCalcMathConstant* c2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	__mpc_struct _tmp2_ = {0};
	__mpc_struct _tmp3_ = {0};
	gboolean result;
#line 125 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, FALSE);
#line 125 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c2 != NULL, FALSE);
#line 126 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 126 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = TRUE;
#line 499 "gcalc-calculator.c"
	} else {
#line 126 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = !GCALC_IS_CONSTANT (c2);
#line 503 "gcalc-calculator.c"
	}
#line 126 "../gcalc/gcalc-calculator.vala"
	if (_tmp0_) {
#line 127 "../gcalc/gcalc-calculator.vala"
		result = FALSE;
#line 127 "../gcalc/gcalc-calculator.vala"
		return result;
#line 511 "gcalc-calculator.c"
	}
#line 130 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp2_);
#line 130 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c2, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp3_);
#line 130 "../gcalc/gcalc-calculator.vala"
	if (mpc_cmp (&_tmp2_, &_tmp3_) < 0) {
#line 130 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = TRUE;
#line 521 "gcalc-calculator.c"
	} else {
#line 130 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = FALSE;
#line 525 "gcalc-calculator.c"
	}
#line 130 "../gcalc/gcalc-calculator.vala"
	result = _tmp1_;
#line 130 "../gcalc/gcalc-calculator.vala"
	return result;
#line 531 "gcalc-calculator.c"
}

/**
     * Calculates the cosine of c1 angle at the given units
     */
GCalcMathConstant*
gcalc_calculator_cos (GCalcMathConstant* c1,
                      GCalcAngleUnit units)
{
	GCalcConstant* a = NULL;
	GCalcConstant* _tmp0_;
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcConstant* _tmp5_;
	__mpc_struct _tmp6_ = {0};
	MPFRGRealRef* _tmp7_;
	GCalcMathConstant* result;
#line 135 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 136 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 136 "../gcalc/gcalc-calculator.vala"
	a = _tmp0_;
#line 137 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 559 "gcalc-calculator.c"
		GCalcMathConstant* _tmp1_;
#line 138 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = gcalc_unit_converter_angle (c1, units, GCALC_ANGLE_UNIT_RADIANS);
#line 138 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (a);
#line 138 "../gcalc/gcalc-calculator.vala"
		a = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 567 "gcalc-calculator.c"
	}
#line 141 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = gcalc_constant_new ();
#line 141 "../gcalc/gcalc-calculator.vala"
	rc = _tmp2_;
#line 142 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp3_);
#line 142 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 142 "../gcalc/gcalc-calculator.vala"
	_tmp5_ = a;
#line 142 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp5_, &_tmp6_);
#line 142 "../gcalc/gcalc-calculator.vala"
	_tmp7_ = mpc_realref (&_tmp6_);
#line 142 "../gcalc/gcalc-calculator.vala"
	mpfr_cos (&_tmp4_->val, &_tmp7_->val, MPFR_RNDN);
#line 143 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 143 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (a);
#line 143 "../gcalc/gcalc-calculator.vala"
	return result;
#line 591 "gcalc-calculator.c"
}

/**
     * Calculates the sine of c1 angle at the given units
     */
GCalcMathConstant*
gcalc_calculator_sin (GCalcMathConstant* c1,
                      GCalcAngleUnit units)
{
	GCalcConstant* a = NULL;
	GCalcConstant* _tmp0_;
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcConstant* _tmp5_;
	__mpc_struct _tmp6_ = {0};
	MPFRGRealRef* _tmp7_;
	GCalcMathConstant* result;
#line 148 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 149 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 149 "../gcalc/gcalc-calculator.vala"
	a = _tmp0_;
#line 150 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 619 "gcalc-calculator.c"
		GCalcMathConstant* _tmp1_;
#line 151 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = gcalc_unit_converter_angle (c1, units, GCALC_ANGLE_UNIT_RADIANS);
#line 151 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (a);
#line 151 "../gcalc/gcalc-calculator.vala"
		a = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 627 "gcalc-calculator.c"
	}
#line 154 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = gcalc_constant_new ();
#line 154 "../gcalc/gcalc-calculator.vala"
	rc = _tmp2_;
#line 155 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp3_);
#line 155 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 155 "../gcalc/gcalc-calculator.vala"
	_tmp5_ = a;
#line 155 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp5_, &_tmp6_);
#line 155 "../gcalc/gcalc-calculator.vala"
	_tmp7_ = mpc_realref (&_tmp6_);
#line 155 "../gcalc/gcalc-calculator.vala"
	mpfr_sin (&_tmp4_->val, &_tmp7_->val, MPFR_RNDN);
#line 156 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 156 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (a);
#line 156 "../gcalc/gcalc-calculator.vala"
	return result;
#line 651 "gcalc-calculator.c"
}

/**
     * Calculates the tangent of c1 angle at the given units
     */
GCalcMathConstant*
gcalc_calculator_tan (GCalcMathConstant* c1,
                      GCalcAngleUnit units)
{
	GCalcConstant* a = NULL;
	GCalcConstant* _tmp0_;
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcConstant* _tmp5_;
	__mpc_struct _tmp6_ = {0};
	MPFRGRealRef* _tmp7_;
	GCalcMathConstant* result;
#line 161 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 162 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new_assign (c1);
#line 162 "../gcalc/gcalc-calculator.vala"
	a = _tmp0_;
#line 163 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 679 "gcalc-calculator.c"
		GCalcMathConstant* _tmp1_;
#line 164 "../gcalc/gcalc-calculator.vala"
		_tmp1_ = gcalc_unit_converter_angle (c1, units, GCALC_ANGLE_UNIT_RADIANS);
#line 164 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (a);
#line 164 "../gcalc/gcalc-calculator.vala"
		a = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 687 "gcalc-calculator.c"
	}
#line 167 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = gcalc_constant_new ();
#line 167 "../gcalc/gcalc-calculator.vala"
	rc = _tmp2_;
#line 168 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp3_);
#line 168 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 168 "../gcalc/gcalc-calculator.vala"
	_tmp5_ = a;
#line 168 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp5_, &_tmp6_);
#line 168 "../gcalc/gcalc-calculator.vala"
	_tmp7_ = mpc_realref (&_tmp6_);
#line 168 "../gcalc/gcalc-calculator.vala"
	mpfr_tan (&_tmp4_->val, &_tmp7_->val, MPFR_RNDN);
#line 169 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 169 "../gcalc/gcalc-calculator.vala"
	_g_object_unref0 (a);
#line 169 "../gcalc/gcalc-calculator.vala"
	return result;
#line 711 "gcalc-calculator.c"
}

/**
     * Calculates the arc, in the given units, represented by the cosine of c1
     */
GCalcMathConstant*
gcalc_calculator_acos (GCalcMathConstant* c1,
                       GCalcAngleUnit units)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp1_;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	__mpc_struct _tmp5_ = {0};
	MPFRGRealRef* _tmp6_;
	GCalcMathConstant* result;
#line 174 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 175 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 733 "gcalc-calculator.c"
		GCalcConstant* _tmp0_;
#line 176 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = gcalc_constant_new ();
#line 176 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) _tmp0_;
#line 176 "../gcalc/gcalc-calculator.vala"
		return result;
#line 741 "gcalc-calculator.c"
	}
#line 179 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_constant_new ();
#line 179 "../gcalc/gcalc-calculator.vala"
	rc = _tmp1_;
#line 180 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = rc;
#line 180 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp2_, &_tmp3_);
#line 180 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 180 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp5_);
#line 180 "../gcalc/gcalc-calculator.vala"
	_tmp6_ = mpc_realref (&_tmp5_);
#line 180 "../gcalc/gcalc-calculator.vala"
	mpfr_acos (&_tmp4_->val, &_tmp6_->val, MPFR_RNDN);
#line 182 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 761 "gcalc-calculator.c"
		GCalcConstant* _tmp7_;
		GCalcMathConstant* _tmp8_;
#line 183 "../gcalc/gcalc-calculator.vala"
		_tmp7_ = rc;
#line 183 "../gcalc/gcalc-calculator.vala"
		_tmp8_ = gcalc_unit_converter_angle ((GCalcMathConstant*) _tmp7_, GCALC_ANGLE_UNIT_RADIANS, units);
#line 183 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 183 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (rc);
#line 183 "../gcalc/gcalc-calculator.vala"
		return result;
#line 774 "gcalc-calculator.c"
	}
#line 186 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 186 "../gcalc/gcalc-calculator.vala"
	return result;
#line 780 "gcalc-calculator.c"
}

/**
     * Calculates the arc, in the given units, represented by the sine of c1
     */
GCalcMathConstant*
gcalc_calculator_asin (GCalcMathConstant* c1,
                       GCalcAngleUnit units)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp1_;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	__mpc_struct _tmp5_ = {0};
	MPFRGRealRef* _tmp6_;
	GCalcMathConstant* result;
#line 191 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 192 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 802 "gcalc-calculator.c"
		GCalcConstant* _tmp0_;
#line 193 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = gcalc_constant_new ();
#line 193 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) _tmp0_;
#line 193 "../gcalc/gcalc-calculator.vala"
		return result;
#line 810 "gcalc-calculator.c"
	}
#line 196 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_constant_new ();
#line 196 "../gcalc/gcalc-calculator.vala"
	rc = _tmp1_;
#line 197 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = rc;
#line 197 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp2_, &_tmp3_);
#line 197 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 197 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp5_);
#line 197 "../gcalc/gcalc-calculator.vala"
	_tmp6_ = mpc_realref (&_tmp5_);
#line 197 "../gcalc/gcalc-calculator.vala"
	mpfr_acos (&_tmp4_->val, &_tmp6_->val, MPFR_RNDN);
#line 199 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 830 "gcalc-calculator.c"
		GCalcConstant* _tmp7_;
		GCalcMathConstant* _tmp8_;
#line 200 "../gcalc/gcalc-calculator.vala"
		_tmp7_ = rc;
#line 200 "../gcalc/gcalc-calculator.vala"
		_tmp8_ = gcalc_unit_converter_angle ((GCalcMathConstant*) _tmp7_, GCALC_ANGLE_UNIT_RADIANS, units);
#line 200 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 200 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (rc);
#line 200 "../gcalc/gcalc-calculator.vala"
		return result;
#line 843 "gcalc-calculator.c"
	}
#line 203 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 203 "../gcalc/gcalc-calculator.vala"
	return result;
#line 849 "gcalc-calculator.c"
}

/**
     * Calculates the arc, with the given units, represented by the tangent of c1
     */
GCalcMathConstant*
gcalc_calculator_atan (GCalcMathConstant* c1,
                       GCalcAngleUnit units)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp1_;
	GCalcConstant* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	__mpc_struct _tmp5_ = {0};
	MPFRGRealRef* _tmp6_;
	GCalcMathConstant* result;
#line 208 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 209 "../gcalc/gcalc-calculator.vala"
	if (!GCALC_IS_CONSTANT (c1)) {
#line 871 "gcalc-calculator.c"
		GCalcConstant* _tmp0_;
#line 210 "../gcalc/gcalc-calculator.vala"
		_tmp0_ = gcalc_constant_new ();
#line 210 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) _tmp0_;
#line 210 "../gcalc/gcalc-calculator.vala"
		return result;
#line 879 "gcalc-calculator.c"
	}
#line 213 "../gcalc/gcalc-calculator.vala"
	_tmp1_ = gcalc_constant_new ();
#line 213 "../gcalc/gcalc-calculator.vala"
	rc = _tmp1_;
#line 214 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = rc;
#line 214 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (_tmp2_, &_tmp3_);
#line 214 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 214 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp5_);
#line 214 "../gcalc/gcalc-calculator.vala"
	_tmp6_ = mpc_realref (&_tmp5_);
#line 214 "../gcalc/gcalc-calculator.vala"
	mpfr_atan (&_tmp4_->val, &_tmp6_->val, MPFR_RNDN);
#line 216 "../gcalc/gcalc-calculator.vala"
	if (units != GCALC_ANGLE_UNIT_RADIANS) {
#line 899 "gcalc-calculator.c"
		GCalcConstant* _tmp7_;
		GCalcMathConstant* _tmp8_;
#line 217 "../gcalc/gcalc-calculator.vala"
		_tmp7_ = rc;
#line 217 "../gcalc/gcalc-calculator.vala"
		_tmp8_ = gcalc_unit_converter_angle ((GCalcMathConstant*) _tmp7_, GCALC_ANGLE_UNIT_RADIANS, units);
#line 217 "../gcalc/gcalc-calculator.vala"
		result = (GCalcMathConstant*) G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GCALC_TYPE_CONSTANT, GCalcConstant);
#line 217 "../gcalc/gcalc-calculator.vala"
		_g_object_unref0 (rc);
#line 217 "../gcalc/gcalc-calculator.vala"
		return result;
#line 912 "gcalc-calculator.c"
	}
#line 220 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 220 "../gcalc/gcalc-calculator.vala"
	return result;
#line 918 "gcalc-calculator.c"
}

/**
     * Calculates the logarithm base 10 of given c1
     */
GCalcMathConstant*
gcalc_calculator_log10 (GCalcMathConstant* c1)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcMathConstant* result;
#line 225 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 226 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 226 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 227 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 227 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 227 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp3_);
#line 227 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 227 "../gcalc/gcalc-calculator.vala"
	mpfr_log10 (&_tmp2_->val, &_tmp4_->val, MPFR_RNDN);
#line 228 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 228 "../gcalc/gcalc-calculator.vala"
	return result;
#line 954 "gcalc-calculator.c"
}

/**
     * Calculates the the exponential of iven c1
     */
GCalcMathConstant*
gcalc_calculator_exp (GCalcMathConstant* c1)
{
	GCalcConstant* rc = NULL;
	GCalcConstant* _tmp0_;
	__mpc_struct _tmp1_ = {0};
	MPFRGRealRef* _tmp2_;
	__mpc_struct _tmp3_ = {0};
	MPFRGRealRef* _tmp4_;
	GCalcMathConstant* result;
#line 233 "../gcalc/gcalc-calculator.vala"
	g_return_val_if_fail (c1 != NULL, NULL);
#line 234 "../gcalc/gcalc-calculator.vala"
	_tmp0_ = gcalc_constant_new ();
#line 234 "../gcalc/gcalc-calculator.vala"
	rc = _tmp0_;
#line 235 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (rc, &_tmp1_);
#line 235 "../gcalc/gcalc-calculator.vala"
	_tmp2_ = mpc_realref (&_tmp1_);
#line 235 "../gcalc/gcalc-calculator.vala"
	gcalc_constant_get_complex (G_TYPE_CHECK_INSTANCE_CAST (c1, GCALC_TYPE_CONSTANT, GCalcConstant), &_tmp3_);
#line 235 "../gcalc/gcalc-calculator.vala"
	_tmp4_ = mpc_realref (&_tmp3_);
#line 235 "../gcalc/gcalc-calculator.vala"
	mpfr_exp (&_tmp2_->val, &_tmp4_->val, MPFR_RNDN);
#line 236 "../gcalc/gcalc-calculator.vala"
	result = (GCalcMathConstant*) rc;
#line 236 "../gcalc/gcalc-calculator.vala"
	return result;
#line 990 "gcalc-calculator.c"
}

GCalcCalculator*
gcalc_calculator_construct (GType object_type)
{
	GCalcCalculator * self = NULL;
#line 24 "../gcalc/gcalc-calculator.vala"
	self = (GCalcCalculator*) g_object_new (object_type, NULL);
#line 24 "../gcalc/gcalc-calculator.vala"
	return self;
#line 1001 "gcalc-calculator.c"
}

GCalcCalculator*
gcalc_calculator_new (void)
{
#line 24 "../gcalc/gcalc-calculator.vala"
	return gcalc_calculator_construct (GCALC_TYPE_CALCULATOR);
#line 1009 "gcalc-calculator.c"
}

static void
gcalc_calculator_class_init (GCalcCalculatorClass * klass,
                             gpointer klass_data)
{
#line 24 "../gcalc/gcalc-calculator.vala"
	gcalc_calculator_parent_class = g_type_class_peek_parent (klass);
#line 1018 "gcalc-calculator.c"
}

static void
gcalc_calculator_instance_init (GCalcCalculator * self,
                                gpointer klass)
{
}

/**
 * A constant calculator for different operations.
 */
static GType
gcalc_calculator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GCalcCalculatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gcalc_calculator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GCalcCalculator), 0, (GInstanceInitFunc) gcalc_calculator_instance_init, NULL };
	GType gcalc_calculator_type_id;
	gcalc_calculator_type_id = g_type_register_static (G_TYPE_OBJECT, "GCalcCalculator", &g_define_type_info, 0);
	return gcalc_calculator_type_id;
}

GType
gcalc_calculator_get_type (void)
{
	static volatile gsize gcalc_calculator_type_id__once = 0;
	if (g_once_init_enter (&gcalc_calculator_type_id__once)) {
		GType gcalc_calculator_type_id;
		gcalc_calculator_type_id = gcalc_calculator_get_type_once ();
		g_once_init_leave (&gcalc_calculator_type_id__once, gcalc_calculator_type_id);
	}
	return gcalc_calculator_type_id__once;
}

