/* math-converter.c generated by valac 0.56.11, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY,
	MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY,
	MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))
enum  {
	MATH_CONVERTER_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkGrid parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkGridClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* equation;
	gchar* category;
	gboolean single_category;
	GtkDropDown* category_combo;
	GtkDropDown* from_combo;
	GtkDropDown* to_combo;
	GtkLabel* from_label;
	GtkLabel* to_label;
	gboolean _outer_box_visible;
	gboolean _view_more_visible;
	gboolean _view_more_active;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

VALA_EXTERN GType math_converter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MathConverter, g_object_unref)
VALA_EXTERN MathConverter* math_converter_new (MathEquation* equation);
VALA_EXTERN MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
VALA_EXTERN void math_converter_set_equation (MathConverter* self,
                                  MathEquation* equation);
static void __lambda10_ (MathConverter* self,
                  GParamSpec* pspec);
static void math_converter_update_result_label (MathConverter* self);
static void ___lambda10__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void math_converter_build_category_model (MathConverter* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
VALA_EXTERN gchar* math_converter_get_category (MathConverter* self);
VALA_EXTERN void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkDropDown* combo,
                                         Unit* unit);
VALA_EXTERN void math_converter_get_conversion (MathConverter* self,
                                    Unit** from_unit,
                                    Unit** to_unit);
static void math_converter_update_visibility (MathConverter* self);
VALA_EXTERN void math_converter_set_outer_box_visible (MathConverter* self,
                                           gboolean value);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit** source_unit,
                                         Unit** target_unit);
static void math_converter_build_units_model (MathConverter* self);
static void math_converter_category_combobox_changed_cb (MathConverter* self);
static void _math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void math_converter_swap_button_clicked_cb (MathConverter* self);
static void _math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void math_converter_do_convert (MathConverter* self,
                                Unit** from_unit,
                                Unit** to_unit);
static void math_converter_convert_button_clicked_cb (MathConverter* self);
static void _math_converter_convert_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
VALA_EXTERN gboolean math_converter_get_outer_box_visible (MathConverter* self);
VALA_EXTERN gboolean math_converter_get_view_more_visible (MathConverter* self);
VALA_EXTERN void math_converter_set_view_more_visible (MathConverter* self,
                                           gboolean value);
VALA_EXTERN gboolean math_converter_get_view_more_active (MathConverter* self);
VALA_EXTERN void math_converter_set_view_more_active (MathConverter* self,
                                          gboolean value);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter___lambda11_ (MathConverter* self);
static void __math_converter___lambda11__currency_manager_updated (CurrencyManager* _sender,
                                                            gpointer self);
static void math_converter_finalize (GObject * obj);
static GType math_converter_get_type_once (void);
static void _vala_math_converter_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_math_converter_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 53 "../src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 53 "../src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, NULL);
#line 55 "../src/math-converter.vala"
	math_converter_set_equation (self, equation);
#line 53 "../src/math-converter.vala"
	return self;
#line 185 "math-converter.c"
}

MathConverter*
math_converter_new (MathEquation* equation)
{
#line 53 "../src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 193 "math-converter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "math-converter.c"
}

static void
__lambda10_ (MathConverter* self,
             GParamSpec* pspec)
{
#line 61 "../src/math-converter.vala"
	g_return_if_fail (pspec != NULL);
#line 61 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 212 "math-converter.c"
}

static void
___lambda10__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 61 "../src/math-converter.vala"
	__lambda10_ ((MathConverter*) self, pspec);
#line 222 "math-converter.c"
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* equation)
{
	MathEquation* _tmp0_;
#line 58 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/math-converter.vala"
	g_return_if_fail (equation != NULL);
#line 60 "../src/math-converter.vala"
	_tmp0_ = _g_object_ref0 (equation);
#line 60 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 60 "../src/math-converter.vala"
	self->priv->equation = _tmp0_;
#line 61 "../src/math-converter.vala"
	g_signal_connect_object ((GObject*) equation, "notify::display", (GCallback) ___lambda10__g_object_notify, self, 0);
#line 242 "math-converter.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 64 "../src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 250 "math-converter.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 64 "../src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 258 "math-converter.c"
}

static void
math_converter_build_category_model (MathConverter* self)
{
	GListStore* category_model = NULL;
	GListStore* _tmp0_;
	GList* categories = NULL;
	UnitManager* _tmp1_;
	UnitManager* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GtkDropDown* _tmp9_;
	GListStore* _tmp10_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp11_;
	GtkDropDown* _tmp12_;
#line 64 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT_CATEGORY);
#line 65 "../src/math-converter.vala"
	category_model = _tmp0_;
#line 66 "../src/math-converter.vala"
	_tmp1_ = unit_manager_get_default ();
#line 66 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/math-converter.vala"
	_tmp3_ = unit_manager_get_categories (_tmp2_);
#line 66 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 66 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 66 "../src/math-converter.vala"
	categories = _tmp4_;
#line 67 "../src/math-converter.vala"
	_tmp5_ = categories;
#line 297 "math-converter.c"
	{
		GList* category_collection = NULL;
		GList* category_it = NULL;
#line 67 "../src/math-converter.vala"
		category_collection = _tmp5_;
#line 67 "../src/math-converter.vala"
		for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 305 "math-converter.c"
			UnitCategory* _tmp6_;
			UnitCategory* category = NULL;
#line 67 "../src/math-converter.vala"
			_tmp6_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 67 "../src/math-converter.vala"
			category = _tmp6_;
#line 312 "math-converter.c"
			{
				GListStore* _tmp7_;
				UnitCategory* _tmp8_;
#line 69 "../src/math-converter.vala"
				_tmp7_ = category_model;
#line 69 "../src/math-converter.vala"
				_tmp8_ = category;
#line 69 "../src/math-converter.vala"
				g_list_store_append (_tmp7_, (GObject*) _tmp8_);
#line 67 "../src/math-converter.vala"
				_g_object_unref0 (category);
#line 324 "math-converter.c"
			}
		}
	}
#line 71 "../src/math-converter.vala"
	_tmp9_ = self->priv->category_combo;
#line 71 "../src/math-converter.vala"
	_tmp10_ = category_model;
#line 71 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp9_, (GListModel*) _tmp10_);
#line 73 "../src/math-converter.vala"
	_tmp11_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT_CATEGORY, NULL, "display_name");
#line 73 "../src/math-converter.vala"
	expression = _tmp11_;
#line 76 "../src/math-converter.vala"
	_tmp12_ = self->priv->category_combo;
#line 76 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp12_, (GtkExpression*) expression);
#line 64 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 64 "../src/math-converter.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 64 "../src/math-converter.vala"
	_g_object_unref0 (category_model);
#line 348 "math-converter.c"
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 79 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 81 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 82 "../src/math-converter.vala"
		return;
#line 366 "math-converter.c"
	}
#line 83 "../src/math-converter.vala"
	_tmp1_ = g_strdup (category);
#line 83 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 83 "../src/math-converter.vala"
	self->priv->category = _tmp1_;
#line 84 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 84 "../src/math-converter.vala"
	if (_tmp2_ != NULL) {
#line 378 "math-converter.c"
		UnitCategory* unit_category = NULL;
		UnitManager* _tmp3_;
		UnitManager* _tmp4_;
		const gchar* _tmp5_;
		UnitCategory* _tmp6_;
		UnitCategory* _tmp7_;
		guint position = 0U;
		GListStore* model = NULL;
		GtkDropDown* _tmp8_;
		GListModel* _tmp9_;
		GListStore* _tmp10_;
		GListStore* _tmp11_;
		UnitCategory* _tmp12_;
		guint _tmp13_ = 0U;
		GtkDropDown* _tmp14_;
#line 85 "../src/math-converter.vala"
		self->priv->single_category = TRUE;
#line 86 "../src/math-converter.vala"
		_tmp3_ = unit_manager_get_default ();
#line 86 "../src/math-converter.vala"
		_tmp4_ = _tmp3_;
#line 86 "../src/math-converter.vala"
		_tmp5_ = self->priv->category;
#line 86 "../src/math-converter.vala"
		_tmp6_ = unit_manager_get_category (_tmp4_, _tmp5_);
#line 86 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 86 "../src/math-converter.vala"
		_g_object_unref0 (_tmp4_);
#line 86 "../src/math-converter.vala"
		unit_category = _tmp7_;
#line 87 "../src/math-converter.vala"
		position = (guint) 0;
#line 88 "../src/math-converter.vala"
		_tmp8_ = self->priv->category_combo;
#line 88 "../src/math-converter.vala"
		_tmp9_ = gtk_drop_down_get_model (_tmp8_);
#line 88 "../src/math-converter.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, g_list_store_get_type ()) ? ((GListStore*) _tmp9_) : NULL);
#line 88 "../src/math-converter.vala"
		model = _tmp10_;
#line 89 "../src/math-converter.vala"
		_tmp11_ = model;
#line 89 "../src/math-converter.vala"
		_tmp12_ = unit_category;
#line 89 "../src/math-converter.vala"
		g_list_store_find (_tmp11_, (GObject*) _tmp12_, &_tmp13_);
#line 89 "../src/math-converter.vala"
		position = _tmp13_;
#line 90 "../src/math-converter.vala"
		_tmp14_ = self->priv->category_combo;
#line 90 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp14_, position);
#line 84 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 84 "../src/math-converter.vala"
		_g_object_unref0 (unit_category);
#line 436 "math-converter.c"
	} else {
		GtkDropDown* _tmp15_;
#line 92 "../src/math-converter.vala"
		self->priv->single_category = FALSE;
#line 93 "../src/math-converter.vala"
		_tmp15_ = self->priv->category_combo;
#line 93 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp15_, (guint) 0);
#line 445 "math-converter.c"
	}
}

gchar*
math_converter_get_category (MathConverter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 99 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 101 "../src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 101 "../src/math-converter.vala"
	result = _tmp1_;
#line 101 "../src/math-converter.vala"
	return result;
#line 465 "math-converter.c"
}

void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Unit* _tmp9_;
	GtkDropDown* _tmp12_;
	Unit* _tmp13_;
	GtkDropDown* _tmp14_;
	Unit* _tmp15_;
#line 104 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/math-converter.vala"
	g_return_if_fail (unit_a != NULL);
#line 104 "../src/math-converter.vala"
	g_return_if_fail (unit_b != NULL);
#line 106 "../src/math-converter.vala"
	_tmp0_ = unit_manager_get_default ();
#line 106 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
#line 106 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 106 "../src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 106 "../src/math-converter.vala"
	ua = _tmp3_;
#line 107 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_default ();
#line 107 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 107 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
#line 107 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 107 "../src/math-converter.vala"
	_g_object_unref0 (_tmp5_);
#line 107 "../src/math-converter.vala"
	ub = _tmp7_;
#line 108 "../src/math-converter.vala"
	_tmp9_ = ua;
#line 108 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 108 "../src/math-converter.vala"
		_tmp8_ = TRUE;
#line 525 "math-converter.c"
	} else {
		Unit* _tmp10_;
#line 108 "../src/math-converter.vala"
		_tmp10_ = ub;
#line 108 "../src/math-converter.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 532 "math-converter.c"
	}
#line 108 "../src/math-converter.vala"
	if (_tmp8_) {
#line 536 "math-converter.c"
		GtkDropDown* _tmp11_;
#line 110 "../src/math-converter.vala"
		_tmp11_ = self->priv->from_combo;
#line 110 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp11_, (guint) 0);
#line 111 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 111 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 111 "../src/math-converter.vala"
		return;
#line 548 "math-converter.c"
	}
#line 114 "../src/math-converter.vala"
	_tmp12_ = self->priv->from_combo;
#line 114 "../src/math-converter.vala"
	_tmp13_ = ua;
#line 114 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp12_, _tmp13_);
#line 115 "../src/math-converter.vala"
	_tmp14_ = self->priv->to_combo;
#line 115 "../src/math-converter.vala"
	_tmp15_ = ub;
#line 115 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp14_, _tmp15_);
#line 104 "../src/math-converter.vala"
	_g_object_unref0 (ub);
#line 104 "../src/math-converter.vala"
	_g_object_unref0 (ua);
#line 566 "math-converter.c"
}

void
math_converter_get_conversion (MathConverter* self,
                               Unit** from_unit,
                               Unit** to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	Unit* _tmp3_;
	GtkDropDown* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	Unit* _tmp7_;
#line 118 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 121 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 121 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 121 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT) ? ((Unit*) _tmp2_) : NULL);
#line 121 "../src/math-converter.vala"
	_g_object_unref0 (_vala_from_unit);
#line 121 "../src/math-converter.vala"
	_vala_from_unit = _tmp3_;
#line 122 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 122 "../src/math-converter.vala"
	_tmp5_ = gtk_drop_down_get_selected_item (_tmp4_);
#line 122 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 122 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_UNIT) ? ((Unit*) _tmp6_) : NULL);
#line 122 "../src/math-converter.vala"
	_g_object_unref0 (_vala_to_unit);
#line 122 "../src/math-converter.vala"
	_vala_to_unit = _tmp7_;
#line 118 "../src/math-converter.vala"
	if (from_unit) {
#line 118 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 614 "math-converter.c"
	} else {
#line 118 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 618 "math-converter.c"
	}
#line 118 "../src/math-converter.vala"
	if (to_unit) {
#line 118 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 624 "math-converter.c"
	} else {
#line 118 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 628 "math-converter.c"
	}
}

static void
math_converter_update_visibility (MathConverter* self)
{
	GtkDropDown* _tmp0_;
	const gchar* _tmp1_;
	CurrencyManager* _tmp2_;
	CurrencyManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 125 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/math-converter.vala"
	_tmp0_ = self->priv->category_combo;
#line 127 "../src/math-converter.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !self->priv->single_category);
#line 128 "../src/math-converter.vala"
	_tmp1_ = self->priv->category;
#line 128 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp1_, "currency") != 0) {
#line 129 "../src/math-converter.vala"
		math_converter_set_outer_box_visible (self, TRUE);
#line 130 "../src/math-converter.vala"
		return;
#line 655 "math-converter.c"
	}
#line 133 "../src/math-converter.vala"
	_tmp2_ = currency_manager_get_default (TRUE, TRUE);
#line 133 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 133 "../src/math-converter.vala"
	_tmp4_ = currency_manager_get_loaded (_tmp3_);
#line 133 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 133 "../src/math-converter.vala"
	math_converter_set_outer_box_visible (self, _tmp5_);
#line 133 "../src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 669 "math-converter.c"
}

static void
math_converter_update_result_label (MathConverter* self)
{
	MathEquation* _tmp0_;
	Number* x = NULL;
	MathEquation* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* z = NULL;
	Number* _tmp5_;
	Unit* _tmp6_ = NULL;
	Unit* _tmp7_ = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
#line 137 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 139 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 140 "../src/math-converter.vala"
		return;
#line 697 "math-converter.c"
	}
#line 141 "../src/math-converter.vala"
	_tmp1_ = self->priv->equation;
#line 141 "../src/math-converter.vala"
	_tmp2_ = math_equation_get_number (_tmp1_);
#line 141 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 141 "../src/math-converter.vala"
	x = _tmp3_;
#line 142 "../src/math-converter.vala"
	_tmp4_ = x;
#line 142 "../src/math-converter.vala"
	if (_tmp4_ == NULL) {
#line 143 "../src/math-converter.vala"
		_g_object_unref0 (x);
#line 143 "../src/math-converter.vala"
		return;
#line 715 "math-converter.c"
	}
#line 146 "../src/math-converter.vala"
	_tmp5_ = x;
#line 146 "../src/math-converter.vala"
	_tmp8_ = math_converter_convert_equation (self, _tmp5_, &_tmp6_, &_tmp7_);
#line 146 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 146 "../src/math-converter.vala"
	source_unit = _tmp6_;
#line 146 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 146 "../src/math-converter.vala"
	target_unit = _tmp7_;
#line 146 "../src/math-converter.vala"
	z = _tmp8_;
#line 147 "../src/math-converter.vala"
	_tmp9_ = z;
#line 147 "../src/math-converter.vala"
	if (_tmp9_ != NULL) {
#line 735 "math-converter.c"
		gchar* source_text = NULL;
		Unit* _tmp10_;
		Number* _tmp11_;
		gchar* _tmp12_;
		gchar* target_text = NULL;
		Unit* _tmp13_;
		Number* _tmp14_;
		gchar* _tmp15_;
		GtkLabel* _tmp16_;
		const gchar* _tmp17_;
		GtkLabel* _tmp18_;
		const gchar* _tmp19_;
#line 149 "../src/math-converter.vala"
		_tmp10_ = source_unit;
#line 149 "../src/math-converter.vala"
		_tmp11_ = x;
#line 149 "../src/math-converter.vala"
		_tmp12_ = unit_format (_tmp10_, _tmp11_);
#line 149 "../src/math-converter.vala"
		source_text = _tmp12_;
#line 150 "../src/math-converter.vala"
		_tmp13_ = target_unit;
#line 150 "../src/math-converter.vala"
		_tmp14_ = z;
#line 150 "../src/math-converter.vala"
		_tmp15_ = unit_format (_tmp13_, _tmp14_);
#line 150 "../src/math-converter.vala"
		target_text = _tmp15_;
#line 151 "../src/math-converter.vala"
		_tmp16_ = self->priv->from_label;
#line 151 "../src/math-converter.vala"
		_tmp17_ = source_text;
#line 151 "../src/math-converter.vala"
		gtk_label_set_text (_tmp16_, _tmp17_);
#line 152 "../src/math-converter.vala"
		_tmp18_ = self->priv->to_label;
#line 152 "../src/math-converter.vala"
		_tmp19_ = target_text;
#line 152 "../src/math-converter.vala"
		gtk_label_set_text (_tmp18_, _tmp19_);
#line 147 "../src/math-converter.vala"
		_g_free0 (target_text);
#line 147 "../src/math-converter.vala"
		_g_free0 (source_text);
#line 780 "math-converter.c"
	}
#line 137 "../src/math-converter.vala"
	_g_object_unref0 (z);
#line 137 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 137 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 137 "../src/math-converter.vala"
	_g_object_unref0 (x);
#line 790 "math-converter.c"
}

static void
math_converter_build_units_model (MathConverter* self)
{
	GListStore* unit_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GtkDropDown* _tmp2_;
	GtkPropertyExpression* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkPropertyExpression* _tmp5_;
	UnitCategory* c = NULL;
	UnitManager* _tmp6_;
	UnitManager* _tmp7_;
	const gchar* _tmp8_;
	UnitCategory* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	GList* _tmp12_;
	guint model_size = 0U;
	GListStore* _tmp16_;
	GtkDropDown* _tmp17_;
	GListStore* _tmp18_;
	GtkDropDown* _tmp19_;
	GtkDropDown* _tmp20_;
	GListStore* _tmp21_;
	GtkDropDown* _tmp22_;
#line 156 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT);
#line 158 "../src/math-converter.vala"
	unit_model = _tmp0_;
#line 160 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "display_name");
#line 160 "../src/math-converter.vala"
	expression = _tmp1_;
#line 163 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 163 "../src/math-converter.vala"
	_tmp3_ = expression;
#line 163 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp2_, (GtkExpression*) _tmp3_);
#line 164 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 164 "../src/math-converter.vala"
	_tmp5_ = expression;
#line 164 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp4_, (GtkExpression*) _tmp5_);
#line 166 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_default ();
#line 166 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 166 "../src/math-converter.vala"
	_tmp8_ = self->priv->category;
#line 166 "../src/math-converter.vala"
	_tmp9_ = unit_manager_get_category (_tmp7_, _tmp8_);
#line 166 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 166 "../src/math-converter.vala"
	_g_object_unref0 (_tmp7_);
#line 166 "../src/math-converter.vala"
	c = _tmp10_;
#line 167 "../src/math-converter.vala"
	_tmp11_ = c;
#line 167 "../src/math-converter.vala"
	_tmp12_ = unit_category_get_units (_tmp11_);
#line 860 "math-converter.c"
	{
		GList* unit_collection = NULL;
		GList* unit_it = NULL;
#line 167 "../src/math-converter.vala"
		unit_collection = _tmp12_;
#line 167 "../src/math-converter.vala"
		for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 868 "math-converter.c"
			Unit* _tmp13_;
			Unit* unit = NULL;
#line 167 "../src/math-converter.vala"
			_tmp13_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 167 "../src/math-converter.vala"
			unit = _tmp13_;
#line 875 "math-converter.c"
			{
				GListStore* _tmp14_;
				Unit* _tmp15_;
#line 169 "../src/math-converter.vala"
				_tmp14_ = unit_model;
#line 169 "../src/math-converter.vala"
				_tmp15_ = unit;
#line 169 "../src/math-converter.vala"
				g_list_store_append (_tmp14_, (GObject*) _tmp15_);
#line 167 "../src/math-converter.vala"
				_g_object_unref0 (unit);
#line 887 "math-converter.c"
			}
		}
	}
#line 172 "../src/math-converter.vala"
	_tmp16_ = unit_model;
#line 172 "../src/math-converter.vala"
	model_size = g_list_model_get_n_items ((GListModel*) _tmp16_);
#line 173 "../src/math-converter.vala"
	_tmp17_ = self->priv->to_combo;
#line 173 "../src/math-converter.vala"
	_tmp18_ = unit_model;
#line 173 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp17_, (GListModel*) _tmp18_);
#line 174 "../src/math-converter.vala"
	_tmp19_ = self->priv->to_combo;
#line 174 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp19_, model_size > ((guint) 10));
#line 175 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_combo;
#line 175 "../src/math-converter.vala"
	_tmp21_ = unit_model;
#line 175 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp20_, (GListModel*) _tmp21_);
#line 176 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_combo;
#line 176 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp22_, model_size > ((guint) 10));
#line 156 "../src/math-converter.vala"
	_g_object_unref0 (c);
#line 156 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 156 "../src/math-converter.vala"
	_g_object_unref0 (unit_model);
#line 921 "math-converter.c"
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkDropDown* combo,
                                Unit* unit)
{
	guint position = 0U;
	GListStore* model = NULL;
	GListModel* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	guint _tmp3_ = 0U;
	gboolean result;
#line 179 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 179 "../src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 179 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 181 "../src/math-converter.vala"
	position = (guint) 0;
#line 182 "../src/math-converter.vala"
	_tmp0_ = gtk_drop_down_get_model (combo);
#line 182 "../src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ()) ? ((GListStore*) _tmp0_) : NULL);
#line 182 "../src/math-converter.vala"
	model = _tmp1_;
#line 183 "../src/math-converter.vala"
	_tmp2_ = model;
#line 183 "../src/math-converter.vala"
	g_list_store_find (_tmp2_, (GObject*) unit, &_tmp3_);
#line 183 "../src/math-converter.vala"
	position = _tmp3_;
#line 184 "../src/math-converter.vala"
	if (position == ((guint) -1)) {
#line 185 "../src/math-converter.vala"
		result = FALSE;
#line 185 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 185 "../src/math-converter.vala"
		return result;
#line 964 "math-converter.c"
	}
#line 186 "../src/math-converter.vala"
	gtk_drop_down_set_selected (combo, position);
#line 187 "../src/math-converter.vala"
	result = TRUE;
#line 187 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 187 "../src/math-converter.vala"
	return result;
#line 974 "math-converter.c"
}

static void
math_converter_category_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	UnitCategory* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkDropDown* _tmp6_;
#line 191 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/math-converter.vala"
	_tmp0_ = self->priv->category_combo;
#line 193 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 193 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 193 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp2_) : NULL);
#line 193 "../src/math-converter.vala"
	category = _tmp3_;
#line 195 "../src/math-converter.vala"
	_tmp4_ = unit_category_get_name (category);
#line 195 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 195 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 195 "../src/math-converter.vala"
	self->priv->category = _tmp5_;
#line 197 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 198 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 199 "../src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 199 "../src/math-converter.vala"
	gtk_drop_down_set_selected (_tmp6_, (guint) 0);
#line 191 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 1018 "math-converter.c"
}

static void
_math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_category_combobox_changed_cb ((MathConverter*) self);
#line 1028 "math-converter.c"
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
#line 203 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 207 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 1040 "math-converter.c"
}

static void
_math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 1050 "math-converter.c"
}

static void
math_converter_swap_button_clicked_cb (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	GtkDropDown* _tmp2_;
	GtkDropDown* _tmp3_;
#line 211 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
#line 214 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 214 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 214 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 214 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 216 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 216 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp2_, to_unit);
#line 217 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_combo;
#line 217 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp3_, from_unit);
#line 219 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 211 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 211 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 1088 "math-converter.c"
}

static void
_math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_swap_button_clicked_cb ((MathConverter*) self);
#line 1097 "math-converter.c"
}

static void
math_converter_do_convert (MathConverter* self,
                           Unit** from_unit,
                           Unit** to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	Number* x = NULL;
	MathEquation* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 222 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 223 "../src/math-converter.vala"
	_tmp1_ = math_equation_get_number (_tmp0_);
#line 223 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 223 "../src/math-converter.vala"
	x = _tmp2_;
#line 224 "../src/math-converter.vala"
	_g_object_unref0 (_vala_from_unit);
#line 224 "../src/math-converter.vala"
	_vala_from_unit = NULL;
#line 225 "../src/math-converter.vala"
	_g_object_unref0 (_vala_to_unit);
#line 225 "../src/math-converter.vala"
	_vala_to_unit = NULL;
#line 226 "../src/math-converter.vala"
	_tmp3_ = x;
#line 226 "../src/math-converter.vala"
	if (_tmp3_ != NULL) {
#line 1134 "math-converter.c"
		Number* z = NULL;
		Number* _tmp4_;
		Unit* _tmp5_ = NULL;
		Unit* _tmp6_ = NULL;
		Number* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		Number* _tmp10_;
#line 228 "../src/math-converter.vala"
		_tmp4_ = x;
#line 228 "../src/math-converter.vala"
		_tmp7_ = math_converter_convert_equation (self, _tmp4_, &_tmp5_, &_tmp6_);
#line 228 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 228 "../src/math-converter.vala"
		_vala_from_unit = _tmp5_;
#line 228 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 228 "../src/math-converter.vala"
		_vala_to_unit = _tmp6_;
#line 228 "../src/math-converter.vala"
		z = _tmp7_;
#line 229 "../src/math-converter.vala"
		_tmp10_ = z;
#line 229 "../src/math-converter.vala"
		if (_tmp10_ != NULL) {
#line 1161 "math-converter.c"
			Unit* _tmp11_;
#line 229 "../src/math-converter.vala"
			_tmp11_ = _vala_from_unit;
#line 229 "../src/math-converter.vala"
			_tmp9_ = _tmp11_ != NULL;
#line 1167 "math-converter.c"
		} else {
#line 229 "../src/math-converter.vala"
			_tmp9_ = FALSE;
#line 1171 "math-converter.c"
		}
#line 229 "../src/math-converter.vala"
		if (_tmp9_) {
#line 1175 "math-converter.c"
			Unit* _tmp12_;
#line 229 "../src/math-converter.vala"
			_tmp12_ = _vala_to_unit;
#line 229 "../src/math-converter.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 1181 "math-converter.c"
		} else {
#line 229 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 1185 "math-converter.c"
		}
#line 229 "../src/math-converter.vala"
		if (_tmp8_) {
#line 1189 "math-converter.c"
			MathEquation* _tmp13_;
			MathEquation* _tmp14_;
			Serializer* _tmp15_;
			Serializer* _tmp16_;
			Number* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			Unit* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			Unit* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			MathEquation* _tmp28_;
#line 231 "../src/math-converter.vala"
			_tmp13_ = self->priv->equation;
#line 231 "../src/math-converter.vala"
			_tmp14_ = self->priv->equation;
#line 231 "../src/math-converter.vala"
			_tmp15_ = math_equation_get_serializer (_tmp14_);
#line 231 "../src/math-converter.vala"
			_tmp16_ = _tmp15_;
#line 231 "../src/math-converter.vala"
			_tmp17_ = x;
#line 231 "../src/math-converter.vala"
			_tmp18_ = serializer_to_string (_tmp16_, _tmp17_);
#line 231 "../src/math-converter.vala"
			_tmp19_ = _tmp18_;
#line 231 "../src/math-converter.vala"
			_tmp20_ = _vala_from_unit;
#line 231 "../src/math-converter.vala"
			_tmp21_ = unit_get_symbol_from_format (_tmp20_);
#line 231 "../src/math-converter.vala"
			_tmp22_ = _tmp21_;
#line 231 "../src/math-converter.vala"
			_tmp23_ = _vala_to_unit;
#line 231 "../src/math-converter.vala"
			_tmp24_ = unit_get_symbol_from_format (_tmp23_);
#line 231 "../src/math-converter.vala"
			_tmp25_ = _tmp24_;
#line 231 "../src/math-converter.vala"
			_tmp26_ = g_strdup_printf ("%s %s %s %s", _tmp19_, _tmp22_, _ ("in"), _tmp25_);
#line 231 "../src/math-converter.vala"
			_tmp27_ = _tmp26_;
#line 231 "../src/math-converter.vala"
			math_equation_set (_tmp13_, _tmp27_);
#line 231 "../src/math-converter.vala"
			_g_free0 (_tmp27_);
#line 231 "../src/math-converter.vala"
			_g_free0 (_tmp25_);
#line 231 "../src/math-converter.vala"
			_g_free0 (_tmp22_);
#line 231 "../src/math-converter.vala"
			_g_free0 (_tmp19_);
#line 232 "../src/math-converter.vala"
			_tmp28_ = self->priv->equation;
#line 232 "../src/math-converter.vala"
			math_equation_solve (_tmp28_);
#line 1250 "math-converter.c"
		}
#line 226 "../src/math-converter.vala"
		_g_object_unref0 (z);
#line 1254 "math-converter.c"
	}
#line 222 "../src/math-converter.vala"
	_g_object_unref0 (x);
#line 222 "../src/math-converter.vala"
	if (from_unit) {
#line 222 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 1262 "math-converter.c"
	} else {
#line 222 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 1266 "math-converter.c"
	}
#line 222 "../src/math-converter.vala"
	if (to_unit) {
#line 222 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 1272 "math-converter.c"
	} else {
#line 222 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 1276 "math-converter.c"
	}
}

static void
math_converter_convert_button_clicked_cb (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
#line 238 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/math-converter.vala"
	math_converter_do_convert (self, &_tmp0_, &_tmp1_);
#line 241 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 241 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 241 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 241 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 243 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 238 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 238 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 1305 "math-converter.c"
}

static void
_math_converter_convert_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_convert_button_clicked_cb ((MathConverter*) self);
#line 1314 "math-converter.c"
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit** source_unit,
                                 Unit** target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkDropDown* _tmp2_;
	UnitCategory* category = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	UnitCategory* _tmp8_;
	GtkDropDown* _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	Unit* _tmp12_;
	GtkDropDown* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp15_;
	Unit* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	UnitCategory* _tmp19_;
	UnitCategory* _tmp22_;
	Unit* _tmp23_;
	Unit* _tmp24_;
	Number* _tmp25_;
	Number* result;
#line 246 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "../src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 250 "../src/math-converter.vala"
	_tmp2_ = self->priv->category_combo;
#line 250 "../src/math-converter.vala"
	if (_tmp2_ == NULL) {
#line 250 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 1359 "math-converter.c"
	} else {
		GtkDropDown* _tmp3_;
#line 250 "../src/math-converter.vala"
		_tmp3_ = self->priv->from_combo;
#line 250 "../src/math-converter.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1366 "math-converter.c"
	}
#line 250 "../src/math-converter.vala"
	if (_tmp1_) {
#line 250 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 1372 "math-converter.c"
	} else {
		GtkDropDown* _tmp4_;
#line 250 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_combo;
#line 250 "../src/math-converter.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 1379 "math-converter.c"
	}
#line 250 "../src/math-converter.vala"
	if (_tmp0_) {
#line 251 "../src/math-converter.vala"
		result = NULL;
#line 251 "../src/math-converter.vala"
		if (source_unit) {
#line 251 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 1389 "math-converter.c"
		} else {
#line 251 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 1393 "math-converter.c"
		}
#line 251 "../src/math-converter.vala"
		if (target_unit) {
#line 251 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 1399 "math-converter.c"
		} else {
#line 251 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 1403 "math-converter.c"
		}
#line 251 "../src/math-converter.vala"
		return result;
#line 1407 "math-converter.c"
	}
#line 252 "../src/math-converter.vala"
	_tmp5_ = self->priv->category_combo;
#line 252 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 252 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 252 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp7_) : NULL);
#line 252 "../src/math-converter.vala"
	category = _tmp8_;
#line 253 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 253 "../src/math-converter.vala"
	_tmp10_ = gtk_drop_down_get_selected_item (_tmp9_);
#line 253 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 253 "../src/math-converter.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_UNIT) ? ((Unit*) _tmp11_) : NULL);
#line 253 "../src/math-converter.vala"
	_g_object_unref0 (_vala_source_unit);
#line 253 "../src/math-converter.vala"
	_vala_source_unit = _tmp12_;
#line 254 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 254 "../src/math-converter.vala"
	_tmp14_ = gtk_drop_down_get_selected_item (_tmp13_);
#line 254 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 254 "../src/math-converter.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, TYPE_UNIT) ? ((Unit*) _tmp15_) : NULL);
#line 254 "../src/math-converter.vala"
	_g_object_unref0 (_vala_target_unit);
#line 254 "../src/math-converter.vala"
	_vala_target_unit = _tmp16_;
#line 256 "../src/math-converter.vala"
	_tmp19_ = category;
#line 256 "../src/math-converter.vala"
	if (_tmp19_ == NULL) {
#line 256 "../src/math-converter.vala"
		_tmp18_ = TRUE;
#line 1449 "math-converter.c"
	} else {
		Unit* _tmp20_;
#line 256 "../src/math-converter.vala"
		_tmp20_ = _vala_source_unit;
#line 256 "../src/math-converter.vala"
		_tmp18_ = _tmp20_ == NULL;
#line 1456 "math-converter.c"
	}
#line 256 "../src/math-converter.vala"
	if (_tmp18_) {
#line 256 "../src/math-converter.vala"
		_tmp17_ = TRUE;
#line 1462 "math-converter.c"
	} else {
		Unit* _tmp21_;
#line 256 "../src/math-converter.vala"
		_tmp21_ = _vala_target_unit;
#line 256 "../src/math-converter.vala"
		_tmp17_ = _tmp21_ == NULL;
#line 1469 "math-converter.c"
	}
#line 256 "../src/math-converter.vala"
	if (_tmp17_) {
#line 257 "../src/math-converter.vala"
		result = NULL;
#line 257 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 257 "../src/math-converter.vala"
		if (source_unit) {
#line 257 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 1481 "math-converter.c"
		} else {
#line 257 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 1485 "math-converter.c"
		}
#line 257 "../src/math-converter.vala"
		if (target_unit) {
#line 257 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 1491 "math-converter.c"
		} else {
#line 257 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 1495 "math-converter.c"
		}
#line 257 "../src/math-converter.vala"
		return result;
#line 1499 "math-converter.c"
	}
#line 258 "../src/math-converter.vala"
	_tmp22_ = category;
#line 258 "../src/math-converter.vala"
	_tmp23_ = _vala_source_unit;
#line 258 "../src/math-converter.vala"
	_tmp24_ = _vala_target_unit;
#line 258 "../src/math-converter.vala"
	_tmp25_ = unit_category_convert (_tmp22_, x, _tmp23_, _tmp24_);
#line 258 "../src/math-converter.vala"
	result = _tmp25_;
#line 258 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 258 "../src/math-converter.vala"
	if (source_unit) {
#line 258 "../src/math-converter.vala"
		*source_unit = _vala_source_unit;
#line 1517 "math-converter.c"
	} else {
#line 258 "../src/math-converter.vala"
		_g_object_unref0 (_vala_source_unit);
#line 1521 "math-converter.c"
	}
#line 258 "../src/math-converter.vala"
	if (target_unit) {
#line 258 "../src/math-converter.vala"
		*target_unit = _vala_target_unit;
#line 1527 "math-converter.c"
	} else {
#line 258 "../src/math-converter.vala"
		_g_object_unref0 (_vala_target_unit);
#line 1531 "math-converter.c"
	}
#line 258 "../src/math-converter.vala"
	return result;
#line 1535 "math-converter.c"
}

gboolean
math_converter_get_outer_box_visible (MathConverter* self)
{
	gboolean result;
#line 31 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/math-converter.vala"
	result = self->priv->_outer_box_visible;
#line 31 "../src/math-converter.vala"
	return result;
#line 1548 "math-converter.c"
}

void
math_converter_set_outer_box_visible (MathConverter* self,
                                      gboolean value)
{
	gboolean old_value;
#line 31 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/math-converter.vala"
	old_value = math_converter_get_outer_box_visible (self);
#line 31 "../src/math-converter.vala"
	if (old_value != value) {
#line 31 "../src/math-converter.vala"
		self->priv->_outer_box_visible = value;
#line 31 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY]);
#line 1566 "math-converter.c"
	}
}

gboolean
math_converter_get_view_more_visible (MathConverter* self)
{
	gboolean result;
#line 32 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/math-converter.vala"
	result = self->priv->_view_more_visible;
#line 32 "../src/math-converter.vala"
	return result;
#line 1580 "math-converter.c"
}

void
math_converter_set_view_more_visible (MathConverter* self,
                                      gboolean value)
{
	gboolean old_value;
#line 32 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/math-converter.vala"
	old_value = math_converter_get_view_more_visible (self);
#line 32 "../src/math-converter.vala"
	if (old_value != value) {
#line 32 "../src/math-converter.vala"
		self->priv->_view_more_visible = value;
#line 32 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY]);
#line 1598 "math-converter.c"
	}
}

gboolean
math_converter_get_view_more_active (MathConverter* self)
{
	gboolean result;
#line 33 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/math-converter.vala"
	result = self->priv->_view_more_active;
#line 33 "../src/math-converter.vala"
	return result;
#line 1612 "math-converter.c"
}

void
math_converter_set_view_more_active (MathConverter* self,
                                     gboolean value)
{
	gboolean old_value;
#line 33 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/math-converter.vala"
	old_value = math_converter_get_view_more_active (self);
#line 33 "../src/math-converter.vala"
	if (old_value != value) {
#line 33 "../src/math-converter.vala"
		self->priv->_view_more_active = value;
#line 33 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY]);
#line 1630 "math-converter.c"
	}
}

static void
_math_converter___lambda11_ (MathConverter* self)
{
#line 44 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 45 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 1641 "math-converter.c"
}

static void
__math_converter___lambda11__currency_manager_updated (CurrencyManager* _sender,
                                                       gpointer self)
{
#line 43 "../src/math-converter.vala"
	_math_converter___lambda11_ ((MathConverter*) self);
#line 1650 "math-converter.c"
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	CurrencyManager* _tmp0_;
	CurrencyManager* _tmp1_;
#line 41 "../src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 41 "../src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 41 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 43 "../src/math-converter.vala"
	_tmp0_ = currency_manager_get_default (TRUE, TRUE);
#line 43 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/math-converter.vala"
	g_signal_connect_object (_tmp1_, "updated", (GCallback) __math_converter___lambda11__currency_manager_updated, self, 0);
#line 43 "../src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 48 "../src/math-converter.vala"
	math_converter_build_category_model (self);
#line 49 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 50 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 41 "../src/math-converter.vala"
	return obj;
#line 1685 "math-converter.c"
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
#line 12 "../src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/math-converter.vala"
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_converter_get_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_math_converter_set_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY] = g_param_spec_boolean ("outer-box-visible", "outer-box-visible", "outer-box-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY] = g_param_spec_boolean ("view-more-visible", "view-more-visible", "view-more-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY, math_converter_properties[MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY] = g_param_spec_boolean ("view-more-active", "view-more-active", "view-more-active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 12 "../src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "category_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, category_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_label));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_label));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "category_combobox_changed_cb", G_CALLBACK(_math_converter_category_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "swap_button_clicked_cb", G_CALLBACK(_math_converter_swap_button_clicked_cb_gtk_button_clicked));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "convert_button_clicked_cb", G_CALLBACK(_math_converter_convert_button_clicked_cb_gtk_button_clicked));
#line 38 "../src/math-converter.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "mathconverter");
#line 1734 "math-converter.c"
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
#line 12 "../src/math-converter.vala"
	self->priv = math_converter_get_instance_private (self);
#line 14 "../src/math-converter.vala"
	self->priv->equation = NULL;
#line 18 "../src/math-converter.vala"
	self->priv->single_category = FALSE;
#line 31 "../src/math-converter.vala"
	self->priv->_outer_box_visible = FALSE;
#line 32 "../src/math-converter.vala"
	self->priv->_view_more_visible = FALSE;
#line 33 "../src/math-converter.vala"
	self->priv->_view_more_active = FALSE;
#line 12 "../src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1755 "math-converter.c"
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 12 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 14 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 16 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 1770 "math-converter.c"
}

static GType
math_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
	GType math_converter_type_id;
	math_converter_type_id = g_type_register_static (gtk_grid_get_type (), "MathConverter", &g_define_type_info, 0);
	MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
	return math_converter_type_id;
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__once = 0;
	if (g_once_init_enter (&math_converter_type_id__once)) {
		GType math_converter_type_id;
		math_converter_type_id = math_converter_get_type_once ();
		g_once_init_leave (&math_converter_type_id__once, math_converter_type_id);
	}
	return math_converter_type_id__once;
}

static void
_vala_math_converter_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_outer_box_visible (self));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_view_more_visible (self));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_view_more_active (self));
#line 12 "../src/math-converter.vala"
		break;
#line 1823 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 1829 "math-converter.c"
	}
}

static void
_vala_math_converter_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_outer_box_visible (self, g_value_get_boolean (value));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_VIEW_MORE_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_view_more_visible (self, g_value_get_boolean (value));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_VIEW_MORE_ACTIVE_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_view_more_active (self, g_value_get_boolean (value));
#line 12 "../src/math-converter.vala"
		break;
#line 1861 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 1867 "math-converter.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

